// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	time "time"

	installerv1alpha1 "github.com/kyma-project/kyma/components/kyma-operator/pkg/apis/installer/v1alpha1"
	versioned "github.com/kyma-project/kyma/components/kyma-operator/pkg/client/clientset/versioned"
	internalinterfaces "github.com/kyma-project/kyma/components/kyma-operator/pkg/client/informers/externalversions/internalinterfaces"
	v1alpha1 "github.com/kyma-project/kyma/components/kyma-operator/pkg/client/listers/installer/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// InstallationInformer provides access to a shared informer and lister for
// Installations.
type InstallationInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1alpha1.InstallationLister
}

type installationInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewInstallationInformer constructs a new informer for Installation type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewInstallationInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredInstallationInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredInstallationInformer constructs a new informer for Installation type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredInstallationInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.InstallerV1alpha1().Installations(namespace).List(options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.InstallerV1alpha1().Installations(namespace).Watch(options)
			},
		},
		&installerv1alpha1.Installation{},
		resyncPeriod,
		indexers,
	)
}

func (f *installationInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredInstallationInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *installationInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&installerv1alpha1.Installation{}, f.defaultInformer)
}

func (f *installationInformer) Lister() v1alpha1.InstallationLister {
	return v1alpha1.NewInstallationLister(f.Informer().GetIndexer())
}
